﻿using UnityEngine;
using System.Collections;

public class ChangeMaterial : MonoBehaviour
{
	public string recieverName; //Grass01Tex
	public Texture2D[] textures;

	private Material material;
	private bool _isChange=false;
	private float _blendValue;

	void Awake()
	{
		AddRecievers();
		material = this.renderer.material;
	}

	void Update()
	{
		if(_isChange)
		{
			_blendValue += 0.05f;

			if(_blendValue>=1.0f)
			{
				_blendValue = 1.0f;
				_isChange = false;
			}

			material.SetFloat("_Blend",_blendValue);
		}
	}


	//Çağırma Şekli;
	//Messenger<int>.Broadcast(recieverName,(int)"İstediğimiz Texture Index");
	void nextTextureIndex(int _i)
	{
		//Önceki gösterilen textureı 0 a alıyoruz.
		material.SetTexture("_MainTex",material.GetTexture("_Texture2"));
		//blend değerini 0lıyoruz.
		material.SetFloat("_Blend",0);

		//Sıradakı texture ı set ediyoruz.
		material.SetTexture("_Texture2",textures[_i]);

		_isChange = true;
	}



	void OnDestroy()
	{
		RemoveRecievers();
	}

	void AddRecievers()
	{
		Messenger<int>.AddListener(recieverName,nextTextureIndex);
	}

	void RemoveRecievers()
	{
		Messenger<int>.RemoveListener(recieverName,nextTextureIndex);
	}
}
