﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(CharacterController))]
public class Controller : MonoBehaviour
{
	public float speed = 6.0F;
	public float jumpSpeed = 8.0F;
	public float gravity = 20.0F;
	private Vector3 moveDirection = Vector3.zero;

	public static bool canFly;
	public static bool canJump;

	private CharacterController controller;

	public Animator animator;

	private float curScale = 1;
	private float initFov;

	public GameObject Tırtıl;
	public GameObject Kelebek;
	

	void Start()
	{
		canFly = false;
		canJump = false;
		Messenger.AddListener("jumpAfterHit", jumpAfterHit);
		controller = GetComponent<CharacterController>();
		curScale = Game.scale_;
		this.gameObject.transform.localScale = new Vector3(curScale,curScale,curScale);
		initFov = Camera.main.fieldOfView;


	}

	void Update()
	{
		if(Game.playerMode==1)
		{
			if(Input.GetKey("a") || Input.GetKey("s") || Input.GetKey("d") || Input.GetKey("w"))
			{
				animator.SetBool("Walk", true);
			}
			else
			{
				animator.SetBool("Walk", false);
			}
		}



		speed = 3 + (Game.speed_);

		if(curScale<Game.scale_)
		{
			curScale+=0.001f;
			this.gameObject.transform.localScale = new Vector3(curScale,curScale,curScale);
			this.gameObject.transform.position += new Vector3(0,curScale/80,0);

			Camera.main.fieldOfView = initFov*curScale;
		}


		moveDirection.x = Input.GetAxis("Horizontal");
		moveDirection.x *= speed;
		moveDirection.x = transform.TransformDirection(moveDirection).x;

		if(Game.canMoveVertical)
		{
			if(gameObject.transform.position.z < -5)
			{
				gameObject.transform.position = new Vector3(gameObject.transform.position.x, gameObject.transform.position.y, -5);
			}

			if(gameObject.transform.position.z > 5)
			{
				gameObject.transform.position = new Vector3(gameObject.transform.position.x, gameObject.transform.position.y, 5);
			}

			moveDirection.z = Input.GetAxis("Vertical");
			moveDirection.z *= speed/2;
			moveDirection.z = transform.TransformDirection(moveDirection).z;
		}

		if(Mathf.Abs( controller.velocity.y )<=0.1f) //Her hangi bi şekilde düşüşü durduysa.
		{
			moveDirection.y = 0;
		}

		if (canJump && (controller.isGrounded || canFly))
		{
			if(Game.playerMode!=2)
			{
				animator.SetBool("Jump",false);
				if (Input.GetButton("Jump"))
				{
					moveDirection.y = jumpSpeed;
					animator.SetBool("Jump",true);
				}
			}
			else
			{
				if (Input.GetButton("Jump"))
					moveDirection.y = jumpSpeed;
			}

		}


		moveDirection.y -= gravity * Time.deltaTime;
		controller.Move(moveDirection * Time.deltaTime);

		if(Game.playerMode == 1)
		{
			Tırtıl.SetActive(true);
			Kelebek.SetActive(false);
		}
		else if(Game.playerMode == 2)
		{
			Tırtıl.SetActive(false);
			Kelebek.SetActive(true);
		}
	}

	void jumpAfterHit()
	{
		moveDirection.y = jumpSpeed;
	}

	void OnDestroy()
	{
		Messenger.RemoveListener("jumpAfterHit", jumpAfterHit);
	}
}
