﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(CharacterController))]
public class Enemy : MonoBehaviour
{
	public float speed = 6.0F;
	public float gravity = 20.0F;

	//MOVE LOOP
	public int moveControl;
	public float moveTimer;
	public float moveTimerCD;
	public float waitTimer;
	public float waitTimerCD;

	private Vector3 moveDirection = Vector3.zero;
	private CharacterController controller;
	
	void Start()
	{
		controller = GetComponent<CharacterController>();
	}
	
	void Update()
	{
		Vector3 firstPos = this.transform.position;

		if(moveControl == 0)
		{
			moveDirection.x = 1; //Oyuncuyu takip eden düşman olursa değişecek.
			moveDirection.x *= speed;
			moveDirection.x = transform.TransformDirection(moveDirection).x;
			moveTimer -= Time.deltaTime;
			if(moveTimer <= 0)
			{
				waitTimer = waitTimerCD;
				moveControl = 1;
			}
		}
		else if(moveControl == 1)
		{
			waitTimer -= Time.deltaTime;
			if(waitTimer <= 0)
			{
				moveTimer = moveTimerCD;
				moveControl = 2;
			}
		}
		else if(moveControl == 2)
		{
			moveDirection.x = -1; //Oyuncuyu takip eden düşman olursa değişecek.
			moveDirection.x *= speed;
			moveDirection.x = transform.TransformDirection(moveDirection).x;
			moveTimer -= Time.deltaTime;
			if(moveTimer <= 0)
			{
				waitTimer = waitTimerCD;
				moveControl = 3;
			}
		}
		else if(moveControl == 3)
		{
			waitTimer -= Time.deltaTime;
			if(waitTimer <= 0)
			{
				moveTimer = moveTimerCD;
				moveControl = 0;
			}
		}
		else
		{
			moveDirection.x = 1; //Oyuncuyu takip eden düşman olursa değişecek.
			moveDirection.x *= speed;
			moveDirection.x = transform.TransformDirection(moveDirection).x;	
		}

		if(controller.enabled)
		{
			if(gravity>0)
			{
				moveDirection.y -= gravity * Time.deltaTime;
				controller.Move(moveDirection * Time.deltaTime);
				this.transform.position = new Vector3(this.transform.position.x,this.transform.position.y,0);
			}
			else
			{
				
				controller.Move(moveDirection * Time.deltaTime);
				//this.transform.position = new Vector3(this.transform.position.x,firstPos.y,0);
			}
		}




	}
}
