﻿Shader "BlendTextures(A)"
{
	Properties
	{
		_Blend ("Blend", Range (0, 1)) = 0.5
		_MainTex ("Texture1", 2D) = "white" {}
		_Texture2 ("Texture2", 2D) = "white" {}
	}
	SubShader
	{
		Cull Off
		ZWrite On
		Alphatest Greater 0.5
		//Blend SrcAlpha OneMinusSrcAlpha
		//Tags { "RenderType"="Transparent" }
		//LOD 200
		
		CGPROGRAM
		#pragma surface surf Lambert

		sampler2D _MainTex;
		sampler2D _Texture2;
		float _Blend;

		struct Input
		{
			float2 uv_MainTex;
		};

		void surf (Input IN, inout SurfaceOutput o)
		{
			fixed4 mainCol = tex2D(_MainTex, IN.uv_MainTex);
		    fixed4 texTwoCol = tex2D(_Texture2, IN.uv_MainTex);
		    
		    fixed4 output = lerp(mainCol, texTwoCol, _Blend);
		    o.Albedo = output.rgb;
		    o.Alpha = output.a;
		}
		ENDCG
	} 
	FallBack "Diffuse"
}
