﻿using UnityEngine;
using System.Collections;

public class enemyTopTrigger : MonoBehaviour
{
	public AnimationCurve animCurve;
	public GameObject enemyMesh;
	public GameObject mainParent;
	private int enemyHP;
	
	Vector3 firstScale;
	float newTime;
	bool startHitAnim;



	void Start ()
	{
		enemyHP = Game.enemyHealth_;
		startHitAnim = false;
		firstScale = enemyMesh.transform.localScale;
	}


	void Update ()
	{

		if(enemyHP>0)
		{
			if(startHitAnim)
			{
				if(newTime<1.0f)
				{
					newTime += Time.deltaTime * 2.5f;
					
					if(newTime>1)
					{
						newTime=0;
						startHitAnim = false;
						enemyHP--;
						Debug.Log("Enemy HP--");
						if(enemyHP<=0)
						{
							Destroy(mainParent,3);
							mainParent.rigidbody.isKinematic = true;
							mainParent.GetComponent<CharacterController>().enabled = false;
						}
					}
					
					enemyMesh.transform.localScale = new Vector3(1,firstScale.y * animCurve.Evaluate(newTime),1);
				}
			}
		}
		else
		{
			mainParent.transform.position -= new Vector3(0,0.05f,0);
		}
		
		
	}
	
	void OnTriggerEnter(Collider c)
	{
		if(c.gameObject.tag == "Player")
		{
			Messenger.Broadcast("jumpAfterHit");
			Debug.Log("Enemy Top Hit!");
			startHitAnim = true;
		}
	}
}
